function [pdag,Observed,Latent]=LPCC(data_file, observed_cardinality,C,CZ)
data_file
data=load(data_file)
data_file
if nargin<3
    
% Run SOM
SD_250 = som_data_struct(data);
SM_250=som_make(SD_250,'munits',250);
bmus_250=som_bmus(SM_250,SD_250);
SD_250.labels=num2cell(bmus_250);
SM_250=som_autolabel(SM_250,SD_250,'vote');
%SM_250 = som_label(SM_250,'add',bmus_250,'BMU');
K=som_show(SM_250,'umat','all','norm','d');
h=som_show_add('label',SM_250,'subplot',1);

%run k-means
[c, p, err, ind,c_size] = my_kmeans_clusters(SM_250,20); % find clusterings
    [dummy,i] = min(ind); % select the one with smallest index
    
    
   
    som_show(SM_250,'color',{p{i},sprintf('%d clusters',i)}); % visualize
    colormap(jet(i)), som_recolorbar % change colormap
    
   %run LPCC
   
   ncases = size(data, 1);
cases= num2cell(data');

clusters_size=zeros(1,i);
for h=1:i
data_c{h}=[]
for k=1:length(p{i})
    if p{i}(k)==h
        data_c{h}=[data_c{h};data(k,:)]
        clusters_size(h)=clusters_size(h)+1;
    end
end
end

clusters=[];
for h=1:i
centroid=[];
    for col=1:size(data_c{h},2)
        clust_cols_hist{h,col}=hist(data_c{h}(:,col),observed_cardinality(col))
        clust_cols_p{h,col}=clust_cols_hist{h,col}./sum(clust_cols_hist{h,col});
    for t=1:length(clust_cols_p{h,col})
    if clust_cols_p{h,col}(t)~=0
        clust_cols_e{h,col}(t)=clust_cols_p{h,col}(t)*log10(clust_cols_p{h,col}(t));
    else
        clust_cols_e{h,col}(t)=0;
    end
    end
    clust_cols_ent{h,col}=-sum(clust_cols_e{h,col});
        [o,v]=max(clust_cols_hist{h,col});
        centroid=[centroid v]
    end
    clusters=[clusters; centroid];
end
%    clusters=round(c{i}); %round final clusters to neariest interger.
%  %   clusters=clusters';
%    %find to which cluster each vector was mapped.
%     for j=1:length(bmus_250)
%         clusters_250(j)=c_size{1,i}(bmus_250(j))
%     end
%     clusters_size=zeros(1,i);
%     for j=1:i
%         for k=1:length(clusters_250)
%             if clusters_250(k)==j
%                 clusters_size(j)=clusters_size(j)+1;
%             end
%         end
%     end
else
    clusters=C;
    clusters_size=CZ;
end
    % find initial major clusters
    major_clusters=[];
    mean_clusters_size=mean(clusters_size);
    for j=1:length(clusters_size)
        if clusters_size(j)>mean_clusters_size
    major_clusters=[major_clusters j]
        end
    end
    %try_big=findBigClusters(clusters_size);
MAX_ITER=10;
iter=1;
DAG={};
while (iter<MAX_ITER)

[dag,Latent,Observed]=runLPCC(clusters,major_clusters);

if iter>1 && isequal(dag,DAG{iter-1})
    break;
end
latents=[];
EXO=[];
EXO_L=[];
for i=1:length(Latent)
    latents(i)=Latent(i).PCC_index;
end
num_latent=length(Latent);
for i=1:length(Observed)
    observeds(i)=Observed(i).PCC_index;
end
num_observed=length(Observed);
t=0
for i=1:length(Observed)
    if length(Observed(i).PA)==0
        t=t+1;
        EXO(t)=Observed(i).PCC_index;
    end
end
r=0;
for i=1:length(Latent)
    if length(Latent(i).PA)==0
        t=t+1;
        r=r+1;
        EXO(t)=Latent(i).PCC_index;
        EXO_L(r)=Latent(i).PCC_index;
    end
end
[cc,ij]=create_pcc(clusters)

[cardinality,ch_v,l_ch]=findLatentCardinality(dag,latents,clusters,clusters_size,major_clusters,cc,ij)
[cases_inc,ns]=createIncompleteData(data,latents,observeds,observed_cardinality,cardinality,ch_v,l_ch)
[new_majors,EXV]=selectNewMajors(EXO_L,Observed,Latent,clusters,clusters_size,l_ch,ch_v,ns)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%take only the latent variables as EXO


if length(new_majors)>1
major_clusters=new_majors;
end
DAG{iter}=dag;
MC{iter}=new_majors;
%TR{iter}=track;
E{iter}=EXV;
iter=iter+1;
end

% learn the bnet parameters "to be used to find minor clusters"
[bnet2, LLtrace]=learnParametersEM(dag,ns,cases_inc)

%To view the learned parameters, we use a little Matlab hackery. 
CPT2 = cell(1,length(ns));
for i=1:length(ns)
s=struct(bnet2.CPD{i}); % violate object privacy
CPT2{i}=s.CPT;
end

%find min-minor and min-major for each latent
[Min_minors,Min_majors,Min_priors]=findMinPr(CPT2,Latent,Observed,EXO_L,l_ch);
[Max_minors,Max_majors,Max_priors]=findMaxPr(CPT2,Latent,Observed,EXO_L,l_ch);
    

                
                
%find non-collider
used=new_majors;


m_clusters2=zeros(length(used),size(clusters,2));

for i=1:length(used)
    m_clusters2(i,:)=clusters(used(i),:);
end
depth=2;
%%%%%%%%%%%%%%%%%%%%%%
% find max_PCC_index
%%%%%%%%%%%%%%%%%%%%%%

max_PCC_index=0;
Latent_final2=[];
for l=1:length(Latent)
    if Latent(l).PCC_index > max_PCC_index
        max_PCC_index=Latent(l).PCC_index;
    end
end
for l=1:length(Latent)
    Latent_final{l}=[];
    if length(Latent(l).OCH)>3 %& length(Latent(l).CH)> 2*depth%should have at least 4 children 
        
     [clust_new,clusters_new,clusters_size_new]= findNewClusters(clusters,clusters_size,Latent,Observed,l_ch,ch_v,l);% marginalize the other latent, i.e., all the children of the other latents have major values.
     [minors_s,minors]=unUsedClusters_pr(new_majors,clust_new,clusters_size_new); % remove the major clusters.
     [try_big2,max_th]=findBigClusters_pr4(minors_s,minors,l,data,Latent,Max_minors,Max_majors,Max_priors);
 MC1=[];
     for r=1:length(try_big2)
     MC1=[MC1; clusters(try_big2(r),:)]
 end
     [Observed,Latent_final{l},NUM_PATHS,PATH_Len]=LatentSplit2_pr3(Latent,used,MC1,clusters,clusters_size,clust_new,clusters_new,clusters_size_new,m_clusters2,l,Observed,l_ch{l},data,Latent,Max_minors,Max_majors, Max_priors,l);     
%[Observed,Latent_final{l}]=recursiveLatentSplit2_pr(used,try_big2,clusters,clust_new,clusters_new,clusters_size_new,m_clusters2,l,Observed,l_ch,depth,data,Latent,Min_minors,Min_majors, Min_priors);
  if length(Latent_final{l})>1
      if NUM_PATHS==2 % Serial connection or two branches diverging- undirected links
    for lf=1:length(Latent_final{l})
        if (Latent_final{l}(lf).K{1})==0 % this is the EX of this serial link and replaces the original ex in the final graph
            previous_PCC_index=Latent_final{l}(lf).PCC_index;
            Latent_final{l}(lf).PCC_index=Latent(l).PCC_index;
            Latent_final{l}(lf).name=['L',num2str(Latent_final{l}(lf).PCC_index)];
            for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{1})>0
                if Latent_final{l}(lf2).PATH{1}.PCC_index==previous_PCC_index
            Latent_final{l}(lf2).PATH{1}=Latent_final{l}(lf);
                end
            end
            end
        end
        
    end
for lf=1:length(Latent_final{l})
        if (Latent_final{l}(lf).K{1})>0 %
            previous_PCC_index=Latent_final{l}(lf).PCC_index;
            max_PCC_index=max_PCC_index+1;
            Latent_final{l}(lf).PCC_index=max_PCC_index;
            Latent_final{l}(lf).name=['L',num2str(Latent_final{l}(lf).PCC_index)];
            for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{1})>0
                if Latent_final{l}(lf2).PATH{1}.PCC_index==previous_PCC_index
            Latent_final{l}(lf2).PATH{1}=Latent_final{l}(lf); 
                end
            end
            end
        end
end
%add the undirected links
for lf=1:length(Latent_final{l})
 for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{1})>0
                if Latent_final{l}(lf2).PATH{1}.PCC_index==Latent_final{l}(lf).PCC_index
            Latent_final{l}(lf2).UD=[Latent_final{l}(lf2).UD Latent_final{l}(lf).PCC_index];
            Latent_final{l}(lf).UD=[Latent_final{l}(lf).UD Latent_final{l}(lf2).PCC_index];
                end
            end
            end
end

      end
  if NUM_PATHS>2 % diverging connection with 3 branches or more- directed links     
  for x=1:NUM_PATHS
  
      for lf=1:length(Latent_final{l})
        if (Latent_final{l}(lf).K{x})==0 % this is the EX of this serial link and replaces the original ex in the final graph
            previous_PCC_index=Latent_final{l}(lf).PCC_index;
            Latent_final{l}(lf).PCC_index=Latent(l).PCC_index;
            Latent_final{l}(lf).name=['L',num2str(Latent_final{l}(lf).PCC_index)];
            for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{x})>0
                if Latent_final{l}(lf2).PATH{x}.PCC_index==previous_PCC_index
            Latent_final{l}(lf2).PATH{x}=Latent_final{l}(lf);
                end
            end
            end
        end
        
    end
for lf=1:length(Latent_final{l})
        if (Latent_final{l}(lf).K{x})>0 %
            previous_PCC_index=Latent_final{l}(lf).PCC_index;
            max_PCC_index=max_PCC_index+1;
            Latent_final{l}(lf).PCC_index=max_PCC_index;
            Latent_final{l}(lf).name=['L',num2str(Latent_final{l}(lf).PCC_index)];
            for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{x})>0
                if Latent_final{l}(lf2).PATH{x}.PCC_index==previous_PCC_index
            Latent_final{l}(lf2).PATH{x}=Latent_final{l}(lf); 
                end
            end
            end
        end
end
%add the directed links
for lf=1:length(Latent_final{l})
 for lf2=1:length(Latent_final{l})
            if length(Latent_final{l}(lf2).PATH{x})>0
                if Latent_final{l}(lf2).PATH{x}.PCC_index==Latent_final{l}(lf).PCC_index
            Latent_final{l}(lf2).D=[Latent_final{l}(lf2).D Latent_final{l}(lf).PCC_index];
                end
            end
            end
end 
  end
  end
   % add all latents splited from Latent(l) to the final latents vector
 for lf=1:length(Latent_final{l})
 Latent_final2=[Latent_final2 Latent_final{l}(lf)]
 end
 for l=1:length(Latent)
     flag=1;
     for lf=1:length(Latent_final2)
    if Latent(l).PCC_index==Latent_final2(lf).PCC_index
        flag=0;
    end
     end
     if flag==1
     Latent_final2=[Latent_final2 Latent(l)]
     end
 end
  else % if length(Latent_final{l})<1, then was not split although has more than 3 children
      Latent_final2=[Latent_final2 Latent(l)]
  end
    else
     Latent_final2=[Latent_final2 Latent(l)] % if  length(Latent(l).OCH)<3, then was not split 
    end
end
dag_final=createDag(Observed,Latent_final2); % Add the new observed- latents links after the split

for l1=1:length(Latent)% preverse v-structures as in the previous graph before the split.
   for l2=1:length(Latent) 
       if dag(Latent(l1).PCC_index,Latent(l2).PCC_index)==1
           dag_final(Latent(l1).PCC_index,Latent(l2).PCC_index)=1;
       end
   end
end
pdag=dag_final;
for lf= 1: length(Latent_final2)
if length(Latent_final2(lf).UD)>0
    for ud=1:length(Latent_final2(lf).UD)
    pdag(Latent_final2(lf).PCC_index,Latent_final2(lf).UD(ud))=2;
    pdag(Latent_final2(lf).UD(ud),Latent_final2(lf).PCC_index)=2;
    end
end
end
Latent=Latent_final2;





